﻿(function (angular) {
    'use strict';

    angular
        .module('airportDelay')
        .controller('AirportInfoCtrl', ['$scope', 'AirportDelayService', 'AdmobAdService', '$timeout', function ($scope, airportDelayService, admobAdService, $timeout) {

            $scope.onSelectAirport = function (airportCode) {
                $scope.getDelay(airportCode);
                $scope.count++;
                if ($scope.count % 2 === 0) {
                    admobAdService.createInterstitialView();
                }
            };

            $scope.getDelay = function (airportCode) {
                $scope.currentInfo = airportDelayService.getDelay(airportCode);
            };

            $scope.init = function () {
                $scope.airports = airportDelayService.getAirports();
                $scope.airport = {
                    code: 'ATL',
                    state: 'status'
                };
                $scope.count = 0;
                $scope.$on('DELAYS_UPDATED', function () {
                    $scope.getDelay($scope.airport.code);
                });
            };
            $scope.init();
        }]);
})(angular);