﻿(function (angular) {
    'use strict';

    angular
        .module('airportDelay')

        .service('AdmobAdService', ['$rootScope', function ($rootScope) {

            this.init = function () {
                initAd();
                if (window.plugins && window.plugins.AdMob) {
                    window.plugins.AdMob.createBannerView();
                }
            };

            this.createInterstitialView = function () {
                if (window.plugins && window.plugins.AdMob) {
                    window.plugins.AdMob.createInterstitialView();
                }
            };

            this.showInterstitialAd = function () {
                if (window.plugins && window.plugins.AdMob) {
                    window.plugins.AdMob.showInterstitialAd(true,
                    function () {
                    }, function (e) {
                    });
                }
            };

            function initAd() {
                if (window.plugins && window.plugins.AdMob) {
                    var adUnits = {
                        ios: {
                            banner: '',
                            interstitial: ''
                        },
                        android: {
                            banner: 'ca-app-pub-7297466330798202/5856195576',
                            interstitial: 'ca-app-pub-7297466330798202/1286395172'
                        }
                    };
                    var admobid = (/(android)/i.test(navigator.userAgent)) ? adUnits.android : adUnits.ios;

                    window.plugins.AdMob.setOptions({
                        publisherId: admobid.banner,
                        interstitialAdId: admobid.interstitial,
                        bannerAtTop: false, // set to true, to put banner at top
                        overlap: false, // set to true, to allow banner overlap webview
                        offsetTopBar: false, // set to true to avoid ios7 status bar overlap
                        isTesting: false, // receiving test ad
                        autoShow: true // auto show interstitial ad when loaded
                    });

                } else {
                    // alert('admob plugin not ready');
                }
            };
        }]);
})(angular);