﻿(function (angular) {
    'use strict';

    angular
        .module('airportDelay')

        .service('AirportDelayService', ['$rootScope', '$ionicLoading', function ($rootScope, $ionicLoading) {

            var airports = [{
                code: 'ATL',
                city: 'Atlanta - ATL'
            }, {
                code: 'BNA',
                city: 'Nashville - BNA'
            }, {
                code: 'BOS',
                city: 'Boston - BOS'
            }, {
                code: 'BWI',
                city: 'Baltimore - BWI'
            }, {
                code: 'CLE',
                city: 'Cleveland - CLE'
            }, {
                code: 'CLT',
                city: 'Charlotte - CLT'
            }, {
                code: 'CVG',
                city: 'Covington/Cincinnati, OH - CVG'
            }, {
                code: 'DCA',
                city: 'Washington - DCA'
            }, {
                code: 'DEN',
                city: 'Denver - DEN'
            }, {
                code: 'DFW',
                city: 'Dallas-Ft Worth - DFW'
            }, {
                code: 'DTW',
                city: 'Detroit - DTW'
            }, {
                code: 'EWR',
                city: 'Newark - EWR'
            }, {
                code: 'FLL',
                city: 'Fort Lauderdale - FLL'
            }, {
                code: 'IAD',
                city: 'Washington - IAD'
            }, {
                code: 'IAH',
                city: 'Houston - IAH'
            }, {
                code: 'IND',
                city: 'Indianapolis - IND'
            }, {
                code: 'JFK',
                city: 'New York - JFK'
            }, {
                code: 'LAS',
                city: 'Las Vegas - LAS'
            }, {
                code: 'LAX',
                city: 'Los Angeles International - LAX'
            }, {
                code: 'LGA',
                city: 'New York - LGA'
            }, {
                code: 'MCI',
                city: 'Kansas City - MCI'
            }, {
                code: 'MCO',
                city: 'Orlando - MCO'
            }, {
                code: 'MDW',
                city: 'Chicago - MDW'
            }, {
                code: 'MEM',
                city: 'Memphis - MEM'
            }, {
                code: 'MIA',
                city: 'Miami - MIA'
            }, {
                code: 'MSP',
                city: 'Minneapolis - MSP'
            }, {
                code: 'ORD',
                city: 'Chicago - ORD'
            }, {
                code: 'PDX',
                city: 'Portland - PDX'
            }, {
                code: 'PHL',
                city: 'Philadelphia - PHL'
            }, {
                code: 'PHX',
                city: 'Phoenix - PHX'
            }, {
                code: 'PIT',
                city: 'Pittsburgh - PIT'
            }, {
                code: 'RDU',
                city: 'Raleigh/Durham - RDU'
            }, {
                code: 'SAN',
                city: 'San Diego - SAN'
            }, {
                code: 'SEA',
                city: 'Seattle - SEA'
            }, {
                code: 'SFO',
                city: 'San Francisco - SFO'
            }, {
                code: 'SJC',
                city: 'San Jose - SJC'
            }, {
                code: 'SLC',
                city: 'Salt Lake City - SLC'
            }, {
                code: 'STL',
                city: 'St Louis - STL'
            }, {
                code: 'TEB',
                city: 'Teterboro - TEB'
            }, {
                code: 'TPA',
                city: 'Tampa - TPA'
            }];

            var delays = {
                'ATL': {},
                'BNA': {},
                'BOS': {},
                'BWI': {},
                'CLE': {},
                'CLT': {},
                'CVG': {},
                'DCA': {},
                'DEN': {},
                'DFW': {},
                'DTW': {},
                'EWR': {},
                'FLL': {},
                'IAD': {},
                'IAH': {},
                'IND': {},
                'JFK': {},
                'LAS': {},
                'LAX': {},
                'LGA': {},
                'MCI': {},
                'MCO': {},
                'MDW': {},
                'MEM': {},
                'MIA': {},
                'MSP': {},
                'ORD': {},
                'PDX': {},
                'PHL': {},
                'PHX': {},
                'PIT': {},
                'RDU': {},
                'SAN': {},
                'SEA': {},
                'SFO': {},
                'SJC': {},
                'SLC': {},
                'STL': {},
                'TEB': {},
                'TPA': {}
            };

            var init = function () {
                var ref = new Firebase("https://publicdata-airports.firebaseio.com");
                ref.on("value", setAirportDelay);
                $rootScope.loadingData = true;
                $ionicLoading.show({
                    template: '<i class="icon ion-loading-a"></i>'
                });
            };
            init();

            function setAirportDelay(snapshot) {
                $ionicLoading.hide();
                $rootScope.loadingData = false;
                var values = snapshot.val();

                for (var i=0, len=airports.length; i<len; i++) {
                    delays[airports[i].code] = values[airports[i].code];
                }
                $rootScope.infoUpdatedAt = new Date(values._updated);
                $rootScope.credits = values._credits;
                $rootScope.$broadcast('DELAYS_UPDATED');
            }

            this.getAirports = function () {
                return airports;
            };

            this.getDelay = function (airportCode) {
                return delays[airportCode];
            };

        }]);
})(angular);